uniform vec3 uPlaneN;
uniform vec3 uPlaneO;
uniform int uSym;
uniform int uDarken;
uniform float uCurvature;
uniform float uFov;
uniform float uAlpha;
uniform int uFlat;

varying float vMasking;
varying vec3 vVertex;
varying vec3 vNormal;

vec3 getNormal() {
  return uFlat == 0 ? normalize(gl_FrontFacing ? vNormal : -vNormal) : -normalize(cross(dFdy(vVertex), dFdx(vVertex)));
}

vec4 encodeFragColor(const in vec3 linearColor) {
  vec3 color = computeCurvature(vVertex, vNormal, linearColor, uCurvature, uFov);
  if(uDarken == 1) color *= 0.3;
  color *= (0.3 + 0.7 * vMasking);
  if(uSym == 1 && abs(dot(uPlaneN, vVertex - uPlaneO)) < 0.15)
      color = min(color * 1.5, 1.0);
  return uAlpha != 1.0 ? vec4(color * uAlpha, uAlpha) : encodeRGBM(color);
}
